searchNodes=[{"doc":"Generates authentication logic for a resource. mix phx.gen.auth Accounts User users The first argument is the context module followed by the schema module and its plural name (used as the schema table name). For more information about the generated authentication system, see the Overview. Password hashing The password hashing mechanism defaults to bcrypt for Unix systems and pbkdf2 for Windows systems. Both systems use the Comeonin interface. The password hashing mechanism can be overriden with the --hashing-lib option. The following values are supported: bcrypt - bcrypt_elixir pbkdf2 - pbkdf2_elixir argon2 - argon2_elixir For more information about choosing these libraries, see the Comeonin project. Web namespace By default, the controllers and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example: mix phx.gen.auth Accounts User users --web Warehouse Which would generate the controllers, views, templates and associated tests in nested in the MyAppWeb.Warehouse namespace: lib/my_app_web/controllers/warehouse/user_auth.ex lib/my_app_web/controllers/warehouse/user_confirmation_controller.ex lib/my_app_web/views/warehouse/user_confirmation_view.ex lib/my_app_web/templates/warehouse/user_confirmation/new.html.eex test/my_app_web/controllers/warehouse/user_auth_test.exs test/my_app_web/controllers/warehouse/user_confirmation_controller_test.exs and so on... Binary ids The --binary-id option causes the generated migration to use binary_id for its primary key and foreign keys. Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app, :generators, binary_id: false, sample_binary_id: &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration. Custom table names By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix phx.gen.auth Accounts User users --table accounts_users This will cause the generated tables to be named &quot;accounts_users&quot; and &quot;accounts_users_tokens&quot;.","ref":"Mix.Tasks.Phx.Gen.Auth.html","title":"Mix.Tasks.Phx.Gen.Auth","type":"task"},{"doc":"","ref":"Mix.Tasks.Phx.Gen.Auth.html#raise_with_help/1","title":"Mix.Tasks.Phx.Gen.Auth.raise_with_help/1","type":"function"},{"doc":"Overview The purpose of mix phx.gen.auth is to generate a pre-built authentication system into a Phoenix 1.5+ application that follows both security and elixir best practices. By generating code into the user&#39;s application instead of using a library, the user has complete freedom to modify the authentication system so it works best with their app. The following links have more information regarding the motivation and design of the code this generates. José Valim&#39;s blog post - An upcoming authentication solution for Phoenix Original pull request on bare phoenix app Original design spec The following are notes about the generated authentication system.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"The password hashing mechanism defaults to bcrypt for Unix systems and pbkdf2 for Windows systems. Both systems use the Comeonin interface.","ref":"overview.html#password-hashing","title":"Overview - Password hashing","type":"extras"},{"doc":"The generated code ships with an auth module with a handful of plugs that fetch the current account, requires authentication and so on. For instance, for an app named Demo which invoked mix phx.gen.auth Accounts User users, you will find a module named DemoWeb.UserAuth with plugs such as: fetch_current_user - fetches the current user information if available require_authenticated_user - must be invoked after fetch_current_user and requires that a current exists and is authenticated redirect_if_user_is_not_authenticated - used for the few pages that must not be available to authenticated users","ref":"overview.html#forbidding-access","title":"Overview - Forbidding access","type":"extras"},{"doc":"The generated functionality ships with an account confirmation mechanism, where users have to confirm their account, typically by e-mail. However, the generated code does not forbid users from using the application if their accounts have not yet been confirmed. You can trivially add this functionality by customizing the plugs generated in the Auth module.","ref":"overview.html#confirmation","title":"Overview - Confirmation","type":"extras"},{"doc":"The generated code is not integrated with any system to send SMSs or e-mails for confirming accounts, reseting passwords, etc. Instead it simply logs a message to the terminal. It is your responsibility to integrate with the proper system after generation.","ref":"overview.html#notifiers","title":"Overview - Notifiers","type":"extras"},{"doc":"All sessions and tokens are tracked in a separate table. This allows you to track how many sessions are active for each account. You could even expose this information to users if desired. Note that whenever the password changes (either via reset password or directly), all tokens are deleted and the user has to login again on all devices.","ref":"overview.html#tracking-sessions","title":"Overview - Tracking sessions","type":"extras"},{"doc":"An enumeration attack allows an attacker to enumerate all e-mails registered in the application. The generated authentication code protects against enumeration attacks on all endpoints, except in the registration and update e-mail forms. If your application is really sensitive to enumeration attacks, you need to implement your own registration workflow, which tends to be very different from the workflow for most applications.","ref":"overview.html#enumeration-attacks","title":"Overview - Enumeration attacks","type":"extras"},{"doc":"The e-mail lookup is made to be case insensitive. Case insensitive lookups are the default in MySQL and MSSQL but require the citext extension in Postgres.","ref":"overview.html#case-sensitiveness","title":"Overview - Case sensitiveness","type":"extras"},{"doc":"The generated tests run concurrently if you are using a database that supports concurrent tests (Postgres).","ref":"overview.html#concurrent-tests","title":"Overview - Concurrent tests","type":"extras"}]